



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>移动端Web页面问题解决方案</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">移动端Web页面问题解决方案</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 18:13:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1、安卓浏览器看背景图片，有些设备会模糊。</strong></p>
<p>用同等比例的图片在PC机上很清楚，但是手机上很模糊，原因是什么呢？</p>
<p>经过研究，是devicePixelRatio作怪，因为手机分辨率太小，如果按照分辨率来显示网页，这样字会非常小，所以苹果当初就把iPhone 4的960640分辨率，在网页里只显示了480320，这样devicePixelRatio＝2。现在android比较乱，有1.5的，有2的也有3的。</p>
<p>想让图片在手机里显示更为清晰，必须使用2x的背景图来代替img标签（一般情况都是用2倍）。例如一个div的宽高是100100，背景图必须得200200，然后background-size:contain;，这样显示出来的图片就比较清晰了。</p>
<p>代码可以如下：</p>
<div>
<pre class="prettyprint linenums">background:url(../images/icon/all.png) no-repeat center center;<br />
-webkit-background-size:50px 50px;<br />
background-size: 50px 50px;display:inline-block; width:100%; height:50px;
</pre>
</div>
<p>或者指定 background-size:contain;都可以，大家试试！</p>
<p><strong>2、图片加载</strong></p>
<p>若您遇到图片加载很慢的问题，对这种情况，手机开发一般用canvas方法加载：</p>
<p>具体的canvas API 参见：http://javascript.ruanyifeng.com/htmlapi/canvas.html</p>
<p>下面举例说明一个canvas的例子：</p>
<div>
<pre class="prettyprint linenums">&lt;li&gt;&lt;canvas&gt;&lt;/canvas&gt;&lt;/li&gt;
</pre>
</div>
<p>js动态加载图片和li 总共举例17张图片！</p>
<div>
<pre class="prettyprint linenums">var total=17;<br />
var zWin=$(window);<br />
var render=function(){<br />
  var padding=2;<br />
  var winWidth=zWin.width();<br />
  var picWidth=Math.floor((winWidth-padding*3)/4);<br />
  var tmpl ='';<br />
  for (var i=1;i&lt;=totla;i++){<br />
  var p=padding;<br />
  var imgSrc='img/'+i+'.jpg';<br />
  if(i%4==1){<br />
   p=0;<br />
  }<br />
  tmpl +='&lt;li style="width:'+picWidth+'px;height:'+picWidth+'px;padding-left:'+p+'px;padding-top:'+padding+'px;"&gt;&lt;canvas id="cvs_'+i+'"&gt;&lt;/canvas&gt;&lt;/li&gt;';<br />
  var imageObj = new Image();<br />
  imageObj.index = i;<br />
  imageObj.onload = function(){<br />
    var cvs =$('#cvs_'+this.index)[0].getContext('2d');<br />
    cvs.width = this.width;<br />
    cvs.height=this.height;<br />
    cvs.drawImage(this,0,0);<br />
  }<br />
  imageObj.src=imgSrc;<br />
  } 

}<br />
render(); 
</pre>
</div>
<p><strong>3、假如手机网站不用兼容IE浏览器，一般我们会使用zeptojs</strong>。zeptojs内置Touch events方法，具体可以看http://zeptojs.com/#Touch events</p>
<p>看了一下zeptio新版的API，已经支持IE10以上浏览器，对zeptojs可以选择使用！</p>
<p><strong>4、防止手机中网页放大和缩小</strong>，这点是最基本的，最为手机网站开发者来说应该都知道的，就是设置meta中的viewport</p>
<p>还有就是，有些手机网站我们看到如下声明：</p>
<div>复制代码代码如下:</div>
<div>
<p>&lt;!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd"&gt;</p>
</div>
<p>设置了DTD的方式是XHTML的写法，假如我们页面运用的是html5，可以不用设置DTD,直接声明&lt;!DOCTYPE html&gt;。</p>
<p>使用viewport使页面禁止缩放。 通常把user-scalable设置为0来关闭用户对页面视图缩放的行为。</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="viewport" content="user-scalable=0" /&gt;
</pre>
</div>
<p>但是为了更好的兼容，我们会使用完整的viewport设置。</p>
<div>复制代码代码如下:</div>
<div>
<p>&lt;meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=1.0,user-scalable=0" /&gt;</p>
</div>
<div>当然，user-scalable=0,有的人也写成user-scalable=no，都可以的。</div>
<p><strong>5、apple-mobile-web-app-capable</strong></p>
<p>apple-mobile-web-app-capable是设置Web应用是否以全屏模式运行。</p>
<p>语法：</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="apple-mobile-web-app-capable" content="yes"&gt;
</pre>
</div>
<p>说明：</p>
<p>如果content设置为yes，Web应用会以全屏模式运行，反之，则不会。content的默认值是no，表示正常显示。你可以通过只读属性window.navigator.standalone来确定网页是否以全屏模式显示。</p>
<p><strong>6、format-detection</strong></p>
<p>format-detection 启动或禁用自动识别页面中的电话号码。</p>
<p>语法：</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="format-detection" content="telephone=no"&gt;
</pre>
</div>
<p>说明：</p>
<p>默认情况下，设备会自动识别任何可能是电话号码的字符串。设置telephone=no可以禁用这项功能。</p>
<p><strong>7、html5调用安卓或者ios的拨号功能</strong></p>
<p>html5提供了自动调用拨号的标签，只要在a标签的href中添加tel:就可以了。</p>
<p>如下：</p>
<div>
<pre class="prettyprint linenums"> &lt;a href="tel:4008106999,1034"&gt;400-810-6999 转 1034&lt;/a&gt;
</pre>
</div>
<p>拨打手机直接如下</p>
<p>&lt;a href="tel:15677776767"&gt;点击拨打15677776767&lt;/a&gt;<br /><strong>8、html5GPS定位功能</strong></p>
<p>具体请看：http://www.jb51.net/post/html5_GPS_getCurrentPosition</p>
<p>9、上下拉动滚动条时卡顿、慢</p>
<div>
<pre class="prettyprint linenums"> body {<br />
  -webkit-overflow-scrolling: touch;<br />
  overflow-scrolling: touch;<br />
}
</pre>
</div>
<p>Android3+和iOS5+支持CSS3的新属性为overflow-scrolling</p>
<p><strong>10、禁止复制、选中文本</strong></p>
<div>
<pre class="prettyprint linenums">Element {<br />
  -webkit-user-select: none;<br />
  -moz-user-select: none;<br />
  -khtml-user-select: none;<br />
   user-select: none;<br />
}
</pre>
</div>
<p>解决移动设备可选中页面文本(视产品需要而定)</p>
<p><strong>11、长时间按住页面出现闪退</strong></p>
<div>
<pre class="prettyprint linenums">element {<br />
  -webkit-touch-callout: none;<br />
}
</pre>
</div>
<p><strong>12、iphone及ipad下输入框默认内阴影</strong></p>
<div>
<pre class="prettyprint linenums">Element{<br />
  -webkit-appearance: none;<br />
}
</pre>
</div>
<p><strong>13、ios和android下触摸元素时出现半透明灰色遮罩</strong></p>
<div>
<pre class="prettyprint linenums">Element {<br />
  -webkit-tap-highlight-color:rgba(255,255,255,0)<br />
}
</pre>
</div>
<p>设置alpha值为0就可以去除半透明灰色遮罩，备注：transparent的属性值在android下无效。</p>
<p>后面一篇文章有详细介绍，地址：http://www.jb51.net/post/phone_web_ysk</p>
<p><strong>14、active兼容处理 即 伪类 :active 失效</strong></p>
<p>方法一：body添加ontouchstart</p>
<div>
<pre class="prettyprint linenums">&lt;body ontouchstart=""&gt;
</pre>
</div>
<p>方法二：js给 document 绑定 touchstart 或 touchend 事件</p>
<div>
<pre class="prettyprint linenums">&lt;style&gt;<br />
a {<br />
 color: #000;<br />
}<br />
a:active {<br />
 color: #fff;<br />
}<br />
&lt;/style&gt;<br />
&lt;a herf=foo &gt;bar&lt;/a&gt;<br />
&lt;script&gt;<br />
 document.addEventListener('touchstart',function(){},false);<br />
&lt;/script&gt;
</pre>
</div>
<p><strong>15、动画定义3D启用硬件加速</strong></p>
<div>
<pre class="prettyprint linenums">Element {<br />
  -webkit-transform:translate3d(0, 0, 0)<br />
  transform: translate3d(0, 0, 0);<br />
}
</pre>
</div>
<p>注意：3D变形会消耗更多的内存与功耗</p>
<p><strong>16、Retina屏的1px边框</strong></p>
<div>
<pre class="prettyprint linenums">Element{<br />
  border-width: thin;<br />
}
</pre>
</div>
<p><strong>17、webkit mask 兼容处理</strong></p>
<p>某些低端手机不支持css3 mask，可以选择性的降级处理。</p>
<p>比如可以使用js判断来引用不同class：</p>
<div>
<pre class="prettyprint linenums">if( 'WebkitMask' in document.documentElement.style){<br />
  alert('支持mask');<br />
} else {<br />
  alert('不支持mask');<br />
}
</pre>
</div>
<p><strong>18、旋转屏幕时，字体大小调整的问题</strong></p>
<div>
<pre class="prettyprint linenums">html, body, form, fieldset, p, div, h1, h2, h3, h4, h5, h6 {<br />
  -webkit-text-size-adjust:100%;<br />
}
</pre>
</div>
<p><strong>19、transition闪屏</strong></p>
<div>
<pre class="prettyprint linenums">/设置内嵌的元素在 3D 空间如何呈现：保留3D /

-webkit-transform-style: preserve-3d;<br />
/ 设置进行转换的元素的背面在面对用户时是否可见：隐藏 /

-webkit-backface-visibility:hidden;
</pre>
</div>
<p><strong>20、圆角bug</strong></p>
<p>某些Android手机圆角失效</p>
<div>
<pre class="prettyprint linenums">background-clip: padding-box;
</pre>
</div>
<p><strong>21、顶部状态栏背景色</strong></p>
<div>
<pre class="prettyprint linenums">&lt;meta name="apple-mobile-web-app-status-bar-style" content="black" /&gt;
</pre>
</div>
<p>说明：</p>
<p>除非你先使用apple-mobile-web-app-capable指定全屏模式，否则这个meta标签不会起任何作用。</p>
<p>如果content设置为default，则状态栏正常显示。如果设置为blank，则状态栏会有一个黑色的背景。如果设置为blank-translucent，则状态栏显示为黑色半透明。如果设置为default或blank，则页面显示在状态栏的下方，即状态栏占据上方部分，页面占据下方部分，二者没有遮挡对方或被遮挡。如果设置为blank-translucent，则页面会充满屏幕，其中页面顶部会被状态栏遮盖住（会覆盖页面20px高度，而iphone4和itouch4的Retina屏幕为40px）。默认值是default。</p>
<p><strong>22、设置缓存</strong></p>
<div>
<pre class="prettyprint linenums">&lt;meta http-equiv="Cache-Control" content="no-cache" /&gt;
</pre>
</div>
<p>手机页面通常在第一次加载后会进行缓存，然后每次刷新会使用缓存而不是去重新向服务器发送请求。如果不希望使用缓存可以设置no-cache。</p>
<p><strong>23、桌面图标</strong></p>
<div>
<pre class="prettyprint linenums">&lt;link rel="apple-touch-icon" href="touch-icon-iphone.png" /&gt;<br />
&lt;link rel="apple-touch-icon" sizes="76x76" href="touch-icon-ipad.png" /&gt;<br />
&lt;link rel="apple-touch-icon" sizes="120x120" href="touch-icon-iphone-retina.png" /&gt;<br />
&lt;link rel="apple-touch-icon" sizes="152x152" href="touch-icon-ipad-retina.png" /&gt;
</pre>
</div>
<p>iOS下针对不同设备定义不同的桌面图标。如果不定义则以当前屏幕截图作为图标。</p>
<p>上面的写法可能大家会觉得会有默认光泽，下面这种设置方法可以去掉光泽效果，还原设计图的效果！</p>
<div>
<pre class="prettyprint linenums">&lt;link rel="apple-touch-icon-precomposed" href="touch-icon-iphone.png" /&gt;
</pre>
</div>
<p>图片尺寸可以设定为5757（px）或者Retina可以定为114114（px），ipad尺寸为72*72（px)</p>
<p><strong>24、启动画面</strong></p>
<div>
<pre class="prettyprint linenums">&lt;link rel="apple-touch-startup-image" href="start.png"/&gt;
</pre>
</div>
<p>iOS下页面启动加载时显示的画面图片，避免加载时的白屏。</p>
<p>可以通过madia来指定不同的大小：</p>
<div>
<pre class="prettyprint linenums">&lt;!--iPhone--&gt;<br />
&lt;link href="apple-touch-startup-image-320x460.png" media="(device-width: 320px)" rel="apple-touch-startup-image" /&gt;

&lt;!-- iPhone Retina --&gt;<br />
&lt;link href="apple-touch-startup-image-640x920.png" media="(device-width: 320px) and (-webkit-device-pixel-ratio: 2)" rel="apple-touch-startup-image" /&gt;

&lt;!-- iPhone 5 --&gt;<br />
&lt;link rel="apple-touch-startup-image" media="(device-width: 320px) and (device-height: 568px) and (-webkit-device-pixel-ratio: 2)" href="apple-touch-startup-image-640x1096.png"&gt;

&lt;!-- iPad portrait --&gt;<br />
&lt;link href="apple-touch-startup-image-768x1004.png" media="(device-width: 768px) and (orientation: portrait)" rel="apple-touch-startup-image" /&gt;

&lt;!-- iPad landscape --&gt;<br />
&lt;link href="apple-touch-startup-image-748x1024.png" media="(device-width: 768px) and (orientation: landscape)" rel="apple-touch-startup-image" /&gt;

&lt;!-- iPad Retina portrait --&gt;<br />
&lt;link href="apple-touch-startup-image-1536x2008.png" media="(device-width: 1536px) and (orientation: portrait) and (-webkit-device-pixel-ratio: 2)" rel="apple-touch-startup-image" /&gt;

&lt;!-- iPad Retina landscape --&gt;<br />
&lt;link href="apple-touch-startup-image-1496x2048.png"media="(device-width: 1536px) and (orientation: landscape) and (-webkit-device-pixel-ratio: 2)"rel="apple-touch-startup-image" /&gt;
</pre>
</div>
<p><strong>25、浏览器私有及其它meta</strong></p>
<p>以下属性在项目中没有应用过，可以写一个demo测试以下！</p>
<p>QQ浏览器私有</p>
<p>全屏模式</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="x5-fullscreen" content="true"&gt;
</pre>
</div>
<p>强制竖屏</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="x5-orientation" content="portrait"&gt;
</pre>
</div>
<p>强制横屏</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="x5-orientation" content="landscape"&gt;
</pre>
</div>
<p>应用模式</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="x5-page-mode" content="app"&gt;
</pre>
</div>
<p>UC浏览器私有</p>
<p>全屏模式</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="full-screen" content="yes"&gt;
</pre>
</div>
<p>强制竖屏</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="screen-orientation" content="portrait"&gt;
</pre>
</div>
<p>强制横屏</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="screen-orientation" content="landscape"&gt;
</pre>
</div>
<p>应用模式</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="browsermode" content="application"&gt;
</pre>
</div>
<p>其它</p>
<p>针对手持设备优化，主要是针对一些老的不识别viewport的浏览器，比如黑莓</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="HandheldFriendly" content="true"&gt;
</pre>
</div>
<p>微软的老式浏览器</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="MobileOptimized" content="320"&gt;
</pre>
</div>
<p>windows phone 点击无高光</p>
<div>
<pre class="prettyprint linenums">&lt;meta name="msapplication-tap-highlight" content="no"&gt;
</pre>
</div>
<p><strong>26、 IOS中input键盘事件keyup、keydown、keypress支持不是很好</strong></p>
<p>问题是这样的，用input search做模糊搜索的时候，在键盘里面输入关键词，会通过ajax后台查询，然后返回数据，然后再对返回的数据进行关键词标红。用input监听键盘keyup事件，在安卓手机浏览器中是可以的，但是在ios手机浏览器中变红很慢，用输入法输入之后，并未立刻相应keyup事件，只有在通过删除之后才能相应！</p>
<p>解决办法：</p>
<p>可以用html5的oninput事件去代替keyup</p>
<div>
<pre class="prettyprint linenums">&lt;input type="text" id="testInput"&gt;<br />
&lt;script type="text/javascript"&gt;<br />
  document.getElementById('testInput').addEventListener('input', function(e){<br />
    var value = e.target.value;<br />
  });<br />
&lt;/script&gt;
</pre>
</div>
<p>然后就达到类似keyup的效果！</p>
<p><strong>27、h5网站input 设置为type=number的问题</strong></p>
<p>h5网页input 的type设置为number一般会产生三个问题，一个问题是maxlength属性不好用了。另外一个是form提交的时候，默认给取整了。三是部分安卓手机出现样式问题。</p>
<p>问题一解决，我目前用的是js。如下</p>
<div>
<pre class="prettyprint linenums">&lt;input type="number" oninput="checkTextLength(this ,10)"&gt; 

function checkTextLength(obj, length) {<br />
      if(obj.value.length &gt; length)  {<br />
        obj.value = obj.value.substr(0, length);<br />
      }<br />
}
</pre>
</div>
<p>问题二，是因为form提交默认做了表单验证，step默认是1,要设置step属性，假如保留2位小数，写法如下：</p>
<div>
<pre class="prettyprint linenums">&lt;input type="number" step="0.01" /&gt;
</pre>
</div>
<p>关于step，我在这里做简单的介绍，input 中type=number，一般会自动生成一个上下箭头，点击上箭头默认增加一个step，点击下箭头默认会减少一个step。number中默认step是1。也就是step=0.01,可以允许输入2位小数，并且点击上下箭头分别增加0.01和减少0.01。</p>
<p>假如step和min一起使用，那么数值必须在min和max之间。</p>
<p>看下面的例子：</p>
<div>
<pre class="prettyprint linenums">&lt;input type="number" step="3.1" min="1" /&gt;
</pre>
</div>
<p>输入框可以输入哪些数字？</p>
<p>首先，最小值是1，那么可以输入1.0，第二个是可以输入（1+3.1）那就是4.1,以此类推，每次点击上下箭头都会增加或者减少3.1，输入其他数字无效。这就是step的简单介绍。</p>
<p>问题三，去除input默认样式</p>
<div>
<div>
<pre class="prettyprint linenums">input[type=number] {<br />
  -moz-appearance:textfield;<br />
}<br />
input[type=number]::-webkit-inner-spin-button,<br />
input[type=number]::-webkit-outer-spin-button {<br />
  -webkit-appearance: none;<br />
  margin: 0;<br />
}
</pre>
</div>
</div>
<p><strong>28、ios 设置input 按钮样式会被默认样式覆盖</strong></p>
<p>解决方式如下：</p>
<div>
<pre class="prettyprint linenums">input,<br />
textarea {<br />
  border: 0;<br />
  -webkit-appearance: none;<br />
}
</pre>
</div>
<p>设置默认样式为none</p>
<p><strong>29、IOS键盘字母输入，默认首字母大写</strong></p>
<p>解决方案，设置如下属性</p>
<div>
<pre class="prettyprint linenums">&lt;input type="text" autocapitalize="off" /&gt;
</pre>
</div>
<p><strong>30、select 下拉选择设置右对齐</strong></p>
<p>设置如下：</p>
<div>
<pre class="prettyprint linenums">select option {<br />
direction: rtl;<br />
}
</pre>
</div>
<p><strong>31、通过transform进行skew变形，rotate旋转会造成出现锯齿现象</strong></p>
<p>可以设置如下：</p>
<div>
<pre class="prettyprint linenums"> -webkit-transform: rotate(-4deg) skew(10deg) translateZ(0);<br />
  transform: rotate(-4deg) skew(10deg) translateZ(0);<br />
  outline: 1px solid rgba(255,255,255,0)
</pre>
</div>
<p><strong>32、移动端点击300ms延迟</strong></p>
<p>300ms尚可接受，不过因为300ms产生的问题，我们必须要解决。300ms导致用户体验并不是很好，解决这个问题，我们一般在移动端用tap事件来取代click事件。</p>
<p>推荐两个js，一个是fastclick，一个是tap.js</p>
<p>关于300ms延迟，具体请看：http://thx.github.io/mobile/300ms-click-delay/</p>
<p><strong>33、移动端点透问题</strong></p>
<p>案例如下：</p>
<div>
<pre class="prettyprint linenums">&lt;div id="haorooms"&gt;点头事件测试&lt;/div&gt;

&lt;a href="www.jb51.net"&gt;www.jb51.net&lt;/a&gt;
</pre>
</div>
<p>div是绝对定位的蒙层,并且z-index高于a。而a标签是页面中的一个链接，我们给div绑定tap事件：</p>
<div>
<pre class="prettyprint linenums">$('#haorooms').on('tap',function(){<br />
$('#haorooms').hide();<br />
});
</pre>
</div>
<p>我们点击蒙层时 div正常消失，但是当我们在a标签上点击蒙层时，发现a链接被触发，这就是所谓的点透事件。</p>
<p>原因：</p>
<p>touchstart 早于 touchend 早于click。 亦即click的触发是有延迟的，这个时间大概在300ms左右，也就是说我们tap触发之后蒙层隐藏， 此时 click还没有触发，300ms之后由于蒙层隐藏，我们的click触发到了下面的a链接上。<br />解决：</p>
<p>（1）尽量都使用touch事件来替换click事件。例如用touchend事件(推荐)。<br />（2）用fastclick，https://github.com/ftlabs/fastclick<br />（3）用preventDefault阻止a标签的click<br />（4）延迟一定的时间(300ms+)来处理事件 （不推荐）<br />（5）以上一般都能解决，实在不行就换成click事件。<br />下面介绍一下touchend事件，如下：</p>
<div>
<pre class="prettyprint linenums">$("#haorooms").on("touchend", function (event) {<br />
   event.preventDefault();

 });
</pre>
</div>
<p><strong>34、消除 IE10 里面的那个叉号</strong></p>
<div>
<pre class="prettyprint linenums">input:-ms-clear{display:none;}
</pre>
</div>
<p><strong>35、关于 iOS 与 OS X 端字体的优化(横竖屏会出现字体加粗不一致等)</strong></p>
<p>iOS 浏览器横屏时会重置字体大小，设置 text-size-adjust 为 none 可以解决 iOS 上的问题，但桌面版 Safari 的字体缩放功能会失效，因此最佳方案是将 text-size-adjust 为 100% 。</p>
<div>
<pre class="prettyprint linenums">-webkit-text-size-adjust: 100%;<br />
-ms-text-size-adjust: 100%;<br />
text-size-adjust: 100%;
</pre>
</div>
<p><strong>36、关于 iOS 系统中，中文输入法输入英文时，字母之间可能会出现一个六分之一空格</strong></p>
<p>可以通过正则去掉</p>
<div>
<pre class="prettyprint linenums">this.value = this.value.replace(/\u2006/g, '');
</pre>
</div>
<p><strong>37、移动端 HTML5 audio autoplay 失效问题</strong></p>
<p>这个不是 BUG，由于自动播放网页中的音频或视频，会给用户带来一些困扰或者不必要的流量消耗，所以苹果系统和安卓系统通常都会禁止自动播放和使用 JS 的触发播放，必须由用户来触发才可以播放。</p>
<p>解决方法思路：先通过用户 touchstart 触碰，触发播放并暂停（音频开始加载，后面用 JS 再操作就没问题了）。</p>
<p>解决代码：</p>
<div>
<pre class="prettyprint linenums">document.addEventListener('touchstart', function () {<br />
  document.getElementsByTagName('audio')[0].play();<br />
  document.getElementsByTagName('audio')[0].pause();<br />
});
</pre>
</div>
<p><strong>38、移动端 HTML5 input date 不支持 placeholder 问题</strong></p>
<p>这个我感觉没有什么好的解决方案，用如下方法</p>
<div>复制代码代码如下:</div>
<div>
<p>&lt;input placeholder="Date" class="textbox-n" type="text" onfocus="(this.type='date')"&nbsp; id="date"&gt;</p>
</div>
<div>有的浏览器可能要点击两遍！</div>
<p><strong>39、部分机型存在type为search的input，自带close按钮样式修改方法</strong></p>
<p>有些机型的搜索input控件会自带close按钮（一个伪元素），而通常为了兼容所有浏览器，我们会自己实现一个，此时去掉原生close按钮的方法为</p>
<div>
<pre class="prettyprint linenums">#Search::-webkit-search-cancel-button{<br />
  display: none;<br />
}</pre>
</div>
<p>如果想使用原生close按钮，又想使其符合设计风格，可以对这个伪元素的样式进行修改。</p>
<p><strong>40、唤起select的option展开</strong></p>
<p>zepto方式:</p>
<div>
<pre class="prettyprint linenums">$(sltElement).trrgger("mousedown");
</pre>
</div>
<p>原生js方式:</p>
<div>
<pre class="prettyprint linenums">function showDropdown(sltElement) {<br />
  var event;<br />
  event = document.createEvent('MouseEvents');<br />
  event.initMouseEvent('mousedown', true, true, window);<br />
  sltElement.dispatchEvent(event);<br />
};</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv22e19.html">Call for Papers    International Conference for Smart Health &lpar;ICSH&rpar; 2014</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qne4lkq.html">Python开发【第七章】：Python异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlow19.html">ARM汇编常用指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvve10zq.html">CSS选择器，CSS3选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjmyky9.html">CentOS下下删除大量文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde4xlx9.html">mybatis  多参数处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/950rl068.html">jQuery 遍历ul li 添加 移除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdg6l8.html">Laravel 中国 - 巨匠级PHP开发框架 Laravel 中国社区</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymvlx9.html">git 第一次 push 遇到问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mey7voq.html">&lbrack;UIKit学习&rsqb;07&period;关于如何选择UIButton、UILable、UIImageView</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mezjmoq.html">bzoj&colon;3085&colon; 反质数加强版SAPGAP</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ymvwz8.html">当运行docker run -i -t ubuntu &sol;bin&sol;bash时，提示报错Error response from daemon&colon; EOF？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg0z6q.html">&lbrack;swarthmore cs75&rsqb; Compiler 6 &ndash; Garbage Snake</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3rex8.html">Django-website 程序案例系列-17 forms表单验证的字段解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyppln9.html">用ctrl&plus;鼠标滚动调节字体大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r67158.html">USB通信基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g6z30q.html">python，函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4nljxq.html">20155302《网络对抗》Exp9 Web安全基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emyvwe9.html">《OpenGL&reg; ES&trade; 3&period;0 Programming Guide》读书笔记1 ----总览</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkyyv38.html">Multitenant Architecture---PDB与CDB</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gp10579.html">JavaScript快速入门-简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlke1l9.html">vuex实践之路&mdash;&mdash;笔记本应用（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vmox2q.html">关于hive的优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vmxm0q.html">QTP&lowbar;随机生成N个字符（包含数字和字母）</a>
			</li>
						<li><a href="https://www.batexi.com/a/953r1z08.html">《unity 3D 游戏开发 第二版》宣雨松 分享 pdf下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj0vyvq.html">App推荐 &vert; Google Tasks</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko0zyjq.html">Muduo学习笔记&lpar;一&rpar; 什么都不做的EventLoop</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjm7eo8.html">CentOS7安装OpenStack&lpar;Rocky版&rpar;-02&period;安装Keyston认证服务组件（控制节点）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnmzoxq.html">初识kibana</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkgnd38.html">JavaScript中执行环境和栈</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
